#ifndef TWIDDLES_H
#define TWIDDLES_H

#include "complex_float.h"
#include "complex_double.h"
#include "tvector.h"

// exp(i * 2 * pi * k / N)
complex_float make_W_float(int k, int N);

// Forward: exp(-i * 2 * pi * k / N)
// Reverse: exp(+i * 2 * pi * k / N)
complex_float make_W_float(int k, int N, int forward);

// N is the FFT length.
// Half tables (for FFTs) will have length N/2.
// Full tables (for DFTs) will have length N.
tvector<complex_float> half_twiddle_table_float(int N, int forward);
tvector<complex_float> full_twiddle_table_float(int N, int forward);


complex_double make_W_double(int k, int N);
complex_double make_W_double(int k, int N, int forward);
tvector<complex_double> half_twiddle_table_double(int N, int forward);
tvector<complex_double> full_twiddle_table_double(int N, int forward);

#endif // TWIDDLES_H
