#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "tvector.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {input file 1} {input file 2} {output file}\n",
		argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(
	int     argc,
	char ** argv)
{
	char * input_file_name_1;
	char * input_file_name_2;
	char * output_file_name;

	if (argc != 4)
		usage(argv[0]);
	input_file_name_1 = argv[1];
	input_file_name_2 = argv[2];
	output_file_name  = argv[3];

	tvector<float> in1, in2, out;

	if (!in1.load_from_binary_file(input_file_name_1)) {
		fprintf(stderr, "%s:  Couldn't read \"%s\".\n",
			argv[0], input_file_name_1);
		exit(1);
	}
	if (!in2.load_from_binary_file(input_file_name_2)) {
		fprintf(stderr, "%s:  Couldn't read \"%s\".\n",
			argv[0], input_file_name_2);
		exit(1);
	}
	out = in1 - in2;
	out.store_to_binary_file(output_file_name);

	return 0;
}
