#include <stdio.h>
#include <stdlib.h>
#include "fixed_point.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {nb} {nf} {floats ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	float fp;
	fixed_point fx;
	int nb, nf;

	if (argc < 4)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &nb) != 1)
		usage(argv[0]);
	if (sscanf(argv[2], "%d", &nf) != 1)
		usage(argv[0]);

	for (int argi = 3; argi < argc; argi++) {
		if (sscanf(argv[argi], "%f", &fp) != 1)
			usage(argv[0]);
		fx = fixed_point(fp, nb, nf);
		printf("%11.7f -> %0*llx\n",
			fp, (nb+3)>>2, fx.get_value());
	}

	return 0;
}
