#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "tvector.h"
#include "complex_float.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {N} {klo} {khi} {output_file_name}\n",
		argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(
	int     argc,
	char ** argv)
{
	int N, klo, khi, i;
	char * output_file_name;

	if (argc != 5)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &N) != 1)
		usage(argv[0]);
	if (sscanf(argv[2], "%d", &klo) != 1)
		usage(argv[0]);
	if (sscanf(argv[3], "%d", &khi) != 1)
		usage(argv[0]);
	output_file_name = argv[4];

	tvector<complex_float>csdata(N);
	for (i = 0; i < N; i++) {
		if ((i >= klo) && (i < khi))
			csdata[i] = 1.0;
		else
			csdata[i] = 0.0;
	}

	csdata.store_to_binary_file(output_file_name);

	return 0;
}
