#include <iostream>
#include <stdlib.h>
#include <string>
#include "tmatrix.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	std::cerr << "Usage: " << argv0
		<< "{input 1 file name} {input 2 file name}\n",
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	char * input_1_file_name = 0;
	char * input_2_file_name = 0;

	if (argc != 3)
		usage(argv[0]);

	input_1_file_name = argv[1];
	input_2_file_name = argv[2];

	tmatrix<double> A, B, C;

	A.load_from_text_file_or_die(input_1_file_name);
	B.load_from_text_file_or_die(input_2_file_name);
	C = A * B;

	std::cout << C << "\n";

	return 0;
}
