#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "complex_float.h"
#include "tmatrix.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr,
		"Usage: %s {# rows} {# cols} {input file} \n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(
	int     argc,
	char ** argv)
{
	int nr, nc;
	char * input_file_name;

	if (argc < 4)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &nr) != 1)
		usage(argv[0]);
	if (sscanf(argv[2], "%d", &nc) != 1)
		usage(argv[0]);
	for (int argi = 3; argi < argc; argi++) {
		if (argi > 3)
			printf("\n");
		input_file_name = argv[argi];
		tmatrix<float> A(nr, nc);
		A.load_from_binary_file_or_die(input_file_name);
		for (int i = 0; i < nr; i++) {
			for (int j = 0; j < nc; j++) {
				if (j > 0)
					printf(" ");
				printf(" %11.7e", A[i][j]);
			}
			printf("\n");
		}
	}

	return 0;
}
