#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "tvector.h"
#include "complex_float.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {N} {lo} {hi} {output_file_name}\n",
		argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(
	int     argc,
	char ** argv)
{
	int N, i;
	complex_float lo, hi;
	char * output_file_name;

	if (argc != 5)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &N) != 1)
		usage(argv[0]);
	if (!lo.from_string(argv[2]))
		usage(argv[0]);
	if (!hi.from_string(argv[3]))
		usage(argv[0]);
	output_file_name = argv[4];

	tvector<complex_float>csdata(N);
	for (i = 0; i < N; i++) {
		csdata[i] = lo + (hi - lo) * (float)i / (float)N;
	}

	csdata.store_to_binary_file(output_file_name);

	return 0;
}
