#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "complex_float.h"
#include "tmatrix.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr,
		"Usage: %s  {input file} \n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(
	int     argc,
	char ** argv)
{
	char * input_file_name;

	if (argc < 2)
		usage(argv[0]);
	for (int argi = 1; argi < argc; argi++) {
		if (argi > 2)
			printf("\n");
		input_file_name = argv[argi];
		tvector<float> v;
		v.load_from_binary_file_or_die(input_file_name);
		int n = v.get_num_elements();
		for (int i = 0; i < n; i++)
			printf("%11.7e\n", v[i]);
	}

	return 0;
}
