#ifndef COMPLEX_FIXED_POINT_H
#define COMPLEX_FIXED_POINT_H

#include <iostream>
#include <sstream>
#include <iomanip>
#include "fixed_point.h"
#include "complex_float.h"

class complex_fixed_point {
public:

	complex_fixed_point(void);
	complex_fixed_point(fixed_point r, fixed_point i);
	complex_fixed_point(const complex_fixed_point & that);

	complex_fixed_point(complex_float c,
		int num_bits, int num_frac);
	complex_float to_complex_float(int num_frac);

	complex_fixed_point & operator=(complex_fixed_point that);
	complex_fixed_point   operator+(complex_fixed_point that);
	complex_fixed_point   operator-(complex_fixed_point that);
	complex_fixed_point   operator*(complex_fixed_point that);
	complex_fixed_point   operator-(void);

	complex_fixed_point & operator+=(complex_fixed_point that);
	complex_fixed_point & operator-=(complex_fixed_point that);
	complex_fixed_point & operator*=(complex_fixed_point that);

	int operator==(complex_fixed_point that);
	int operator!=(complex_fixed_point that);

	friend std::ostream & operator<<(std::ostream & os,
		const complex_fixed_point & cplx);
	friend std::istream & operator>>(std::istream & is,
		complex_fixed_point & cplx);

public:
	fixed_point re;
	fixed_point im;
};

#endif // COMPLEX_FIXED_POINT_H
