#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "comparecd.h"

// ----------------------------------------------------------------
int complex_double_vector_compare(
	complex_double * actual,
	complex_double * expect,
	int             length,
	double          tol,
	double        & maxrelerr,
	double        & rmsrelerr,
	double        & maxabserr,
	double        & maxabsval)
{
	int     i;
	double  maxmag = 0.0;

	for (i = 0; i < length; i++) {
		double curmag = expect[i].mag();
		if (curmag > maxmag)
			maxmag = curmag;
	}
	if (maxmag == 0.0)
		maxmag = 1.0;

	maxrelerr = 0.0;
	rmsrelerr = 0.0;
	maxabserr = 0.0;
	maxabsval = 0.0;
	for (i = 0; i < length; i++) {
		complex_double diff = actual[i] - expect[i];
		double amag = actual[i].mag();
		double emag = expect[i].mag();
		double curabserr = diff.mag();
		double currelerr = curabserr / maxmag;
		double curabsval = amag > emag ? amag : emag;
		if (currelerr > maxrelerr)
			maxrelerr = currelerr;
		if (curabserr > maxabserr)
			maxabserr = curabserr;
		if (curabsval > maxabsval)
			maxabsval = curabsval;
		rmsrelerr += currelerr * currelerr;
	}
	rmsrelerr /= length;
	rmsrelerr = sqrt(rmsrelerr);

	if (rmsrelerr <= tol)
		return 1;
	else
		return 0;
}
