#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "comparecf.h"

// ----------------------------------------------------------------
int complex_float_vector_compare(
	complex_float * actual,
	complex_float * expect,
	int             length,
	float           tol,
	float         & maxrelerr,
	float         & rmsrelerr,
	float         & maxabserr,
	float         & maxabsval)
{
	int     i;
	float   maxmag = 0.0;

	for (i = 0; i < length; i++) {
		float curmag = expect[i].mag();
		if (curmag > maxmag)
			maxmag = curmag;
	}
	if (maxmag == 0.0)
		maxmag = 1.0;

	maxrelerr = 0.0;
	rmsrelerr = 0.0;
	maxabserr = 0.0;
	maxabsval = 0.0;
	for (i = 0; i < length; i++) {
		complex_float diff = actual[i] - expect[i];
		float amag = actual[i].mag();
		float emag = expect[i].mag();
		float curabsval = amag > emag ? amag : emag;

		float curabserr = diff.mag();
		float currelerr = curabserr / maxmag;
		if (currelerr > maxrelerr)
			maxrelerr = currelerr;
		if (curabserr > maxabserr)
			maxabserr = curabserr;
		if (curabsval > maxabsval)
			maxabsval = curabsval;
		rmsrelerr += currelerr * currelerr;
	}
	rmsrelerr /= length;
	rmsrelerr = sqrt(rmsrelerr);

	if (rmsrelerr <= tol)
		return 1;
	else
		return 0;
}
