#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "compared.h"

// ----------------------------------------------------------------
int double_vector_compare(
	double * actual,
	double * expect,
	int      length,
	double   tol,
	double & maxrelerr,
	double & rmsrelerr,
	double & maxabserr,
	double & maxabsval)
{
	int     i;
	double  maxmag = 0.0;

	for (i = 0; i < length; i++) {
		double curmag = fabs(expect[i]);
		if (curmag > maxmag)
			maxmag = curmag;
	}
	if (maxmag == 0.0)
		maxmag = 1.0;

	maxrelerr = 0.0;
	rmsrelerr = 0.0;
	maxabserr = 0.0;
	maxabsval = 0.0;
	for (i = 0; i < length; i++) {
		double diff = actual[i] - expect[i];
		double amag = fabs(actual[i]);
		double emag = fabs(expect[i]);
		double curabsval = amag > emag ? amag : emag;

		double curabserr = fabs(diff);
		double currelerr = curabserr / maxmag;
		if (currelerr > maxrelerr)
			maxrelerr = currelerr;
		if (curabserr > maxabserr)
			maxabserr = curabserr;
		if (curabsval > maxabsval)
			maxabsval = curabsval;
		rmsrelerr += currelerr * currelerr;
	}
	rmsrelerr /= length;
	rmsrelerr = sqrt(rmsrelerr);

	if (rmsrelerr <= tol)
		return 1;
	else
		return 0;
}
