#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "comparef.h"

// ----------------------------------------------------------------
int float_vector_compare(
	float * actual,
	float * expect,
	int     length,
	float   tol,
	float & maxrelerr,
	float & rmsrelerr,
	float & maxabserr,
	float & maxabsval)
{
	int     i;
	float   maxmag = 0.0;

	for (i = 0; i < length; i++) {
		float curmag = fabs(expect[i]);
		if (curmag > maxmag)
			maxmag = curmag;
	}
	if (maxmag == 0.0)
		maxmag = 1.0;

	maxrelerr = 0.0;
	rmsrelerr = 0.0;
	maxabserr = 0.0;
	maxabsval = 0.0;
	for (i = 0; i < length; i++) {
		float diff = actual[i] - expect[i];
		double amag = fabs(actual[i]);
		double emag = fabs(expect[i]);
		double curabsval = amag > emag ? amag : emag;

		float curabserr = fabs(diff);
		float currelerr = curabserr / maxmag;
		if (currelerr > maxrelerr)
			maxrelerr = currelerr;
		if (curabserr > maxabserr)
			maxabserr = curabserr;
		if (curabsval > maxabsval)
			maxabsval = curabsval;
		rmsrelerr += currelerr * currelerr;
	}
	rmsrelerr /= length;
	rmsrelerr = sqrt(rmsrelerr);

	if (rmsrelerr <= tol)
		return 1;
	else
		return 0;
}
