#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include "fx_taps.h"
#include "fx_vector_print.h"

// ----------------------------------------------------------------
void complex_fixed_point_tap(
	complex_fixed_point * array,
	int    length,
	int    num_frac,
	int    block_exponent,
	char * file_name_format,
	...)
{
	char file_name[512];
	va_list varg_ptr;
	va_start(varg_ptr, file_name_format);
	vsprintf(file_name, file_name_format, varg_ptr);
	va_end(varg_ptr);
	char * tapdir = getenv("TAPDIR");
	if (tapdir) {
		char temp[512];
		strcpy(temp, file_name);
		sprintf(file_name, "%s/%s", tapdir, temp);
	}
	fprintf(stderr, "Writing tap file \"%s\" ... ", file_name);
	fflush(stderr);
	complex_fixed_point_array_to_text_file(array, length, num_frac,
		block_exponent, file_name);
	fprintf(stderr, "Done.\n");
}

// ----------------------------------------------------------------
void fixed_point_tap(
	fixed_point * array,
	int    length,
	int    num_frac,
	int    block_exponent,
	char * file_name_format,
	...)
{
	char file_name[512];
	va_list varg_ptr;
	va_start(varg_ptr, file_name_format);
	vsprintf(file_name, file_name_format, varg_ptr);
	va_end(varg_ptr);
	char * tapdir = getenv("TAPDIR");
	if (tapdir) {
		char temp[512];
		strcpy(temp, file_name);
		sprintf(file_name, "%s/%s", tapdir, temp);
	}
	fprintf(stderr, "Writing tap file \"%s\" ... ", file_name);
	fflush(stderr);
	fixed_point_array_to_text_file(array, length, num_frac,
		block_exponent, file_name);
	fprintf(stderr, "Done.\n");
}
