#ifndef FX_TAPS_H
#define FX_TAPS_H

#include "fixed_point.h"
#include "complex_fixed_point.h"
#include "tvector.h"

// The "..." business means you can do printf-style things like:
//
// complex_float_tap(input_data, N, "mytap.txt");
// complex_float_tap(input_data, N, "mytap-stage-%d.txt", stageno);
//
// Etc.
//
// Output files go to the current directory, unless $TAPDIR is set
// in the environment in which they go there.

void complex_fixed_point_tap(
	complex_fixed_point * array,
	int      length,
	int      num_frac,
	int      block_exponent,
	char   * file_name,
	...);

void fixed_point_tap(
	fixed_point * array,
	int      length,
	int      num_frac,
	int      block_exponent,
	char   * file_name,
	...);

#endif // FX_TAPS_H
