#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "fx_vector_print.h"

#define mypow(a,b) (exp((b)*log(a)))

// ----------------------------------------------------------------
void complex_fixed_point_array_to_text_file(
	complex_fixed_point     * array,
	int                       length,
	int                       num_frac,
	int                       block_exponent,
	char                    * file_name)
{
	FILE * fp = fopen(file_name, "w");
	if (fp == 0) {
		fprintf(stderr, "complex_fixed_point_array_to_file:  "
			"couldn't open \"%s\" for write.\n", file_name);
		exit(1);
	}
	for (int i = 0; i < length; i++) {
		float fpre = array[i].re.to_float(num_frac);
		float fpim = array[i].im.to_float(num_frac);
		fpre *= mypow(2.0, (float)block_exponent);
		fpim *= mypow(2.0, (float)block_exponent);

		fprintf(fp, "0x%016llx 0x%016llx # %11.7e %11.7e\n",
			array[i].re.get_value(), array[i].im.get_value(),
			fpre, fpim);
	}

	fclose(fp);
}

// ----------------------------------------------------------------
void fixed_point_array_to_text_file(
	fixed_point             * array,
	int                       length,
	int                       num_frac,
	int                       block_exponent,
	char                    * file_name)
{
	FILE * fp = fopen(file_name, "w");
	if (fp == 0) {
		fprintf(stderr, "fixed_point_array_to_file:  "
			"couldn't open \"%s\" for write.\n", file_name);
		exit(1);
	}
	for (int i = 0; i < length; i++) {
		float fpval = array[i].to_float(num_frac);
		fpval *= mypow(2.0, (float)block_exponent);
		fprintf(fp, "0x%016llx # %11.7e\n",
			array[i].get_value(), fpval);
	}
	fclose(fp);
}
