#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include "taps.h"
#include "vector_print.h"

// ================================================================
void complex_float_tap(
	complex_float * array,
	int             length,
	char          * file_name_format,
	...)
{
	char file_name[512];
	va_list varg_ptr;
	va_start(varg_ptr, file_name_format);
	vsprintf(file_name, file_name_format, varg_ptr);
	va_end(varg_ptr);
	char * tapdir = getenv("TAPDIR");
	if (tapdir) {
		char temp[512];
		strcpy(temp, file_name);
		sprintf(file_name, "%s/%s", tapdir, temp);
	}
	fprintf(stderr, "Writing tap file \"%s\" ... ", file_name);
	fflush(stderr);
	complex_float_array_to_text_file(array, length, file_name);
	fprintf(stderr, "Done.\n");
}

// ----------------------------------------------------------------
void float_tap(
	float * array,
	int    length,
	char  * file_name_format,
	...)
{
	char file_name[512];
	va_list varg_ptr;
	va_start(varg_ptr, file_name_format);
	vsprintf(file_name, file_name_format, varg_ptr);
	va_end(varg_ptr);
	char * tapdir = getenv("TAPDIR");
	if (tapdir) {
		char temp[512];
		strcpy(temp, file_name);
		sprintf(file_name, "%s/%s", tapdir, temp);
	}
	fprintf(stderr, "Writing tap file \"%s\" ... ", file_name);
	fflush(stderr);
	float_array_to_text_file(array, length, file_name);
	fprintf(stderr, "Done.\n");
}

// ================================================================
void complex_double_tap(
	complex_double * array,
	int              length,
	char           * file_name_format,
	...)
{
	char file_name[512];
	va_list varg_ptr;
	va_start(varg_ptr, file_name_format);
	vsprintf(file_name, file_name_format, varg_ptr);
	va_end(varg_ptr);
	char * tapdir = getenv("TAPDIR");
	if (tapdir) {
		char temp[512];
		strcpy(temp, file_name);
		sprintf(file_name, "%s/%s", tapdir, temp);
	}
	fprintf(stderr, "Writing tap file \"%s\" ... ", file_name);
	fflush(stderr);
	complex_double_array_to_text_file(array, length, file_name);
	fprintf(stderr, "Done.\n");
}

// ----------------------------------------------------------------
void double_tap(
	double * array,
	int      length,
	char   * file_name_format,
	...)
{
	char file_name[512];
	va_list varg_ptr;
	va_start(varg_ptr, file_name_format);
	vsprintf(file_name, file_name_format, varg_ptr);
	va_end(varg_ptr);
	char * tapdir = getenv("TAPDIR");
	if (tapdir) {
		char temp[512];
		strcpy(temp, file_name);
		sprintf(file_name, "%s/%s", tapdir, temp);
	}
	fprintf(stderr, "Writing tap file \"%s\" ... ", file_name);
	fflush(stderr);
	double_array_to_text_file(array, length, file_name);
	fprintf(stderr, "Done.\n");
}
