#ifndef TAPS_H
#define TAPS_H

#include "complex_float.h"
#include "complex_double.h"
#include "tvector.h"

// The "..." business means you can do printf-style things like:
//
// complex_float_tap(input_data, N, "mytap.txt");
// complex_float_tap(input_data, N, "mytap-stage-%d.txt", stageno);
//
// Etc.
//
// Output files go to the current directory, unless $TAPDIR is set
// in the environment in which they go there.

void complex_float_tap(
	complex_float * array,
	int             length,
	char          * file_name,
	...);

void float_tap(
	float * array,
	int     length,
	char  * file_name,
	...);

void complex_double_tap(
	complex_double * array,
	int              length,
	char           * file_name,
	...);

void double_tap(
	double * array,
	int      length,
	char   * file_name,
	...);

#endif // TAPS_H
